Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 863)
+++ src/mlx/gui/common.py	(revision 1002)
@@ -16,13 +16,4 @@
 #
 # Common definitions and utilities for the GUI
-#
-# The main purpose of this module is to provide common definitions for things
-# that are named differently in Gtk+ 2 and 3. This way the other parts of the
-# GUI have to check the version in use very rarely. The variable \c pygobject
-# tells which version is being used. If it is \c True, Gtk+ 3 is used via the
-# PyGObject interface. Otherwise Gtk+ 2 is used, which is the default on
-# Windows or when the \c FORCE_PYGTK environment variable is set.
-#
-# Besides this there are some common utility classes and functions.
 
 #-----------------------------------------------------------------------------
@@ -30,174 +21,21 @@
 appIndicator = False
 
-if not pygobject:
-    print "Using PyGTK"
-    pygobject = False
-    import pygtk
-    pygtk.require("2.0")
-    import gtk.gdk as gdk
-    import gtk
-    import pango
-
-    try:
-        import appindicator
-        appIndicator = True
-    except Exception, e:
-        pass
-
-    MESSAGETYPE_ERROR = gtk.MESSAGE_ERROR
-    MESSAGETYPE_QUESTION = gtk.MESSAGE_QUESTION
-    MESSAGETYPE_INFO = gtk.MESSAGE_INFO
-
-    RESPONSETYPE_NONE = gtk.RESPONSE_NONE
-    RESPONSETYPE_OK = gtk.RESPONSE_OK
-    RESPONSETYPE_YES = gtk.RESPONSE_YES
-    RESPONSETYPE_NO = gtk.RESPONSE_NO
-    RESPONSETYPE_ACCEPT = gtk.RESPONSE_ACCEPT
-    RESPONSETYPE_REJECT = gtk.RESPONSE_REJECT
-    RESPONSETYPE_CANCEL = gtk.RESPONSE_CANCEL
-
-    ACCEL_VISIBLE = gtk.ACCEL_VISIBLE
-    CONTROL_MASK = gdk.CONTROL_MASK
-    DIALOG_MODAL = gtk.DIALOG_MODAL
-    WRAP_WORD = gtk.WRAP_WORD
-
-    JUSTIFY_CENTER = gtk.JUSTIFY_CENTER
-    JUSTIFY_LEFT = gtk.JUSTIFY_LEFT
-
-    CONTROL_MASK = gdk.CONTROL_MASK
-    SHIFT_MASK = gdk.SHIFT_MASK
-    BUTTON1_MASK = gdk.BUTTON1_MASK
-
-    SCROLL_UP = gdk.SCROLL_UP
-    SCROLL_DOWN = gdk.SCROLL_DOWN
-
-    SPIN_USER_DEFINED = gtk.SPIN_USER_DEFINED
-
-    FILE_CHOOSER_ACTION_SELECT_FOLDER = gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER
-    FILE_CHOOSER_ACTION_OPEN = gtk.FILE_CHOOSER_ACTION_OPEN
-    FILE_CHOOSER_ACTION_SAVE = gtk.FILE_CHOOSER_ACTION_SAVE
-
-    SELECTION_MULTIPLE = gtk.SELECTION_MULTIPLE
-
-    SHADOW_IN = gtk.SHADOW_IN
-    SHADOW_NONE = gtk.SHADOW_NONE
-
-    POLICY_AUTOMATIC = gtk.POLICY_AUTOMATIC
-    POLICY_NEVER = gtk.POLICY_NEVER
-    POLICY_ALWAYS = gtk.POLICY_ALWAYS
-
-    WEIGHT_NORMAL = pango.WEIGHT_NORMAL
-    WEIGHT_BOLD = pango.WEIGHT_BOLD
-
-    WINDOW_STATE_ICONIFIED = gdk.WINDOW_STATE_ICONIFIED
-    WINDOW_STATE_WITHDRAWN = gdk.WINDOW_STATE_WITHDRAWN
-
-    SORT_ASCENDING = gtk.SORT_ASCENDING
-    SORT_DESCENDING = gtk.SORT_DESCENDING
-
-    EVENT_BUTTON_PRESS = gdk.BUTTON_PRESS
-
-    TREE_VIEW_COLUMN_FIXED = gtk.TREE_VIEW_COLUMN_FIXED
-
-    FILL = gtk.FILL
-    EXPAND = gtk.EXPAND
-
-    UPDATE_IF_VALID = gtk.UPDATE_IF_VALID
-
-    SELECTION_MULTIPLE = gtk.SELECTION_MULTIPLE
-
-    WINDOW_POPUP = gtk.WINDOW_POPUP
-
-    pixbuf_new_from_file = gdk.pixbuf_new_from_file
-
-    def text2unicode(text):
-        """Convert the given text, returned by a Gtk widget, to Unicode."""
-        return unicode(text)
-
-    def text2str(text):
-        """Convert the given text, returned by xstr to a string."""
-        return str(text)
-
-else: # pygobject
-    from gi.repository import Gdk as gdk
-    from gi.repository import GdkPixbuf as gdkPixbuf
-    from gi.repository import Gtk as gtk
-    from gi.repository import AppIndicator3 as appindicator
-    from gi.repository import Pango as pango
-
+import gi
+gi.require_version("Gdk", "3.0")
+from gi.repository import Gdk
+from gi.repository import GdkPixbuf
+gi.require_version("Gtk", "3.0")
+from gi.repository import Gtk
+try:
+    gi.require_version("AppIndicator3", "0.1")
+    from gi.repository import AppIndicator3
     appIndicator = True
-
-
-    MESSAGETYPE_ERROR = gtk.MessageType.ERROR
-    MESSAGETYPE_QUESTION = gtk.MessageType.QUESTION
-    MESSAGETYPE_INFO = gtk.MessageType.INFO
-    RESPONSETYPE_NONE = gtk.ResponseType.NONE
-    RESPONSETYPE_OK = gtk.ResponseType.OK
-    RESPONSETYPE_YES = gtk.ResponseType.YES
-    RESPONSETYPE_NO = gtk.ResponseType.NO
-    RESPONSETYPE_ACCEPT = gtk.ResponseType.ACCEPT
-    RESPONSETYPE_REJECT = gtk.ResponseType.REJECT
-    RESPONSETYPE_CANCEL = gtk.ResponseType.CANCEL
-    ACCEL_VISIBLE = gtk.AccelFlags.VISIBLE
-    CONTROL_MASK = gdk.ModifierType.CONTROL_MASK
-    DIALOG_MODAL = gtk.DialogFlags.MODAL
-    WRAP_WORD = gtk.WrapMode.WORD
-    JUSTIFY_CENTER = gtk.Justification.CENTER
-    JUSTIFY_LEFT = gtk.Justification.LEFT
-
-    CONTROL_MASK = gdk.ModifierType.CONTROL_MASK
-    SHIFT_MASK = gdk.ModifierType.SHIFT_MASK
-    BUTTON1_MASK = gdk.ModifierType.BUTTON1_MASK
-
-    SCROLL_UP = gdk.ScrollDirection.UP
-    SCROLL_DOWN = gdk.ScrollDirection.DOWN
-
-    SPIN_USER_DEFINED = gtk.SpinType.USER_DEFINED
-
-    FILE_CHOOSER_ACTION_SELECT_FOLDER = gtk.FileChooserAction.SELECT_FOLDER
-    FILE_CHOOSER_ACTION_OPEN = gtk.FileChooserAction.OPEN
-    FILE_CHOOSER_ACTION_SAVE = gtk.FileChooserAction.SAVE
-
-    SELECTION_MULTIPLE = gtk.SelectionMode.MULTIPLE
-
-    SHADOW_IN = gtk.ShadowType.IN
-    SHADOW_NONE = gtk.ShadowType.NONE
-
-    POLICY_AUTOMATIC = gtk.PolicyType.AUTOMATIC
-    POLICY_NEVER = gtk.PolicyType.NEVER
-    POLICY_ALWAYS = gtk.PolicyType.ALWAYS
-
-    WEIGHT_NORMAL = pango.Weight.NORMAL
-    WEIGHT_BOLD = pango.Weight.BOLD
-
-    WINDOW_STATE_ICONIFIED = gdk.WindowState.ICONIFIED
-    WINDOW_STATE_WITHDRAWN = gdk.WindowState.WITHDRAWN
-
-    SORT_ASCENDING = gtk.SortType.ASCENDING
-    SORT_DESCENDING = gtk.SortType.DESCENDING
-
-    EVENT_BUTTON_PRESS = gdk.EventType.BUTTON_PRESS
-
-    TREE_VIEW_COLUMN_FIXED = gtk.TreeViewColumnSizing.FIXED
-
-    FILL = gtk.AttachOptions.FILL
-    EXPAND = gtk.AttachOptions.EXPAND
-
-    UPDATE_IF_VALID = gtk.SpinButtonUpdatePolicy.IF_VALID
-
-    SELECTION_MULTIPLE = gtk.SelectionMode.MULTIPLE
-
-    pixbuf_new_from_file = gdkPixbuf.Pixbuf.new_from_file
-
-    import codecs
-    _utf8Decoder = codecs.getdecoder("utf-8")
-
-    def text2unicode(str):
-        """Convert the given text, returned by a Gtk widget, to Unicode."""
-        return _utf8Decoder(str)[0]
-
-    def text2str(text):
-        """Convert the given text, returned by xstr to a string."""
-        return _utf8Decoder(text)[0]
+except:
+    pass
+from gi.repository import Pango
+from gi.repository import PangoCairo
+
+import codecs
+_utf8Decoder = codecs.getdecoder("utf-8")
 
 import cairo
@@ -240,9 +78,9 @@
 #------------------------------------------------------------------------------
 
-class IntegerEntry(gtk.Entry):
+class IntegerEntry(Gtk.Entry):
     """An entry that allows only either an empty value, or an integer."""
     def __init__(self, defaultValue = None):
         """Construct the entry."""
-        gtk.Entry.__init__(self)
+        Gtk.Entry.__init__(self)
 
         self.set_alignment(1.0)
@@ -292,9 +130,10 @@
 #------------------------------------------------------------------------------
 
-class TimeEntry(gtk.Entry):
+class TimeEntry(Gtk.Entry):
     """Widget to display and edit a time value in HH:MM format."""
     def __init__(self):
         """Construct the entry"""
-        super(TimeEntry, self).__init__(max = 5)
+        super(TimeEntry, self).__init__()
+        self.set_max_width_chars(5)
 
         self.connect("insert-text", self._insertText)
@@ -396,10 +235,10 @@
             pass
         else:
-            gtk.gdk.display_get_default().beep()
+            Gtk.gdk.display_get_default().beep()
             self.stop_emission(signal)
 
 #------------------------------------------------------------------------------
 
-class CredentialsDialog(gtk.Dialog):
+class CredentialsDialog(Gtk.Dialog):
     """A dialog window to ask for a user name and a password."""
     def __init__(self, gui, userName, password,
@@ -414,11 +253,11 @@
                                                 titleLabel,
                                                 gui.mainWindow,
-                                                DIALOG_MODAL)
-        self.add_button(cancelButtonLabel, RESPONSETYPE_CANCEL)
-        self.add_button(okButtonLabel, RESPONSETYPE_OK)
+                                                Gtk.DialogFlags.MODAL)
+        self.add_button(cancelButtonLabel, Gtk.ResponseType.CANCEL)
+        self.add_button(okButtonLabel, Gtk.ResponseType.OK)
 
         contentArea = self.get_content_area()
 
-        contentAlignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        contentAlignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                          xscale = 0.0, yscale = 0.0)
         contentAlignment.set_padding(padding_top = 4, padding_bottom = 16,
@@ -427,19 +266,19 @@
         contentArea.pack_start(contentAlignment, False, False, 0)
 
-        contentVBox = gtk.VBox()
+        contentVBox = Gtk.VBox()
         contentAlignment.add(contentVBox)
 
         if infoText is not None:
-            label = gtk.Label(infoText)
+            label = Gtk.Label(infoText)
             label.set_alignment(0.0, 0.0)
 
             contentVBox.pack_start(label, False, False, 0)
 
-        tableAlignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        tableAlignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                        xscale = 0.0, yscale = 0.0)
         tableAlignment.set_padding(padding_top = 24, padding_bottom = 0,
                                    padding_left = 0, padding_right = 0)
 
-        table = gtk.Table(3, 2)
+        table = Gtk.Table(3, 2)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -449,10 +288,10 @@
         contentVBox.pack_start(tableAlignment, True, True, 0)
 
-        label = gtk.Label(userNameLabel)
+        label = Gtk.Label(userNameLabel)
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 0, 1, 0, 1)
 
-        self._userName = gtk.Entry()
+        self._userName = Gtk.Entry()
         self._userName.set_width_chars(16)
         # FIXME: enabled the OK button only when there is something in thr
@@ -465,10 +304,10 @@
         label.set_mnemonic_widget(self._userName)
 
-        label = gtk.Label(passwordLabel)
+        label = Gtk.Label(passwordLabel)
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
         table.attach(label, 0, 1, 1, 2)
 
-        self._password = gtk.Entry()
+        self._password = Gtk.Entry()
         self._password.set_visibility(False)
         #self._password.connect("changed",
@@ -480,5 +319,5 @@
 
         if rememberPassword is not None:
-            self._rememberButton = gtk.CheckButton(rememberLabel)
+            self._rememberButton = Gtk.CheckButton(rememberLabel)
             self._rememberButton.set_use_underline(True)
             self._rememberButton.set_tooltip_text(rememberTooltip)
@@ -516,5 +355,5 @@
 #------------------------------------------------------------------------------
 
-gobject.signal_new("integer-changed", IntegerEntry, gobject.SIGNAL_RUN_FIRST,
+GObject.signal_new("integer-changed", IntegerEntry, GObject.SIGNAL_RUN_FIRST,
                    None, (object,))
 
@@ -588,5 +427,5 @@
 def addFaultTag(buffer):
     """Add a tag named 'fault' to the given buffer."""
-    buffer.create_tag("fault", foreground="red", weight=WEIGHT_BOLD)
+    buffer.create_tag("fault", foreground="red", weight=Pango.Weight.BOLD)
 
 #------------------------------------------------------------------------------
@@ -622,10 +461,10 @@
 
     Return a boolean indicating the answer."""
-    dialog = gtk.MessageDialog(parent = parent,
-                               type = MESSAGETYPE_QUESTION,
+    dialog = Gtk.MessageDialog(parent = parent,
+                               type = Gtk.MessageType.QUESTION,
                                message_format = question)
 
-    dialog.add_button(xstr("button_no"), RESPONSETYPE_NO)
-    dialog.add_button(xstr("button_yes"), RESPONSETYPE_YES)
+    dialog.add_button(xstr("button_no"), Gtk.ResponseType.NO)
+    dialog.add_button(xstr("button_yes"), Gtk.ResponseType.YES)
 
     dialog.set_title(title)
@@ -633,5 +472,5 @@
     dialog.hide()
 
-    return result==RESPONSETYPE_YES
+    return result==Gtk.ResponseType.YES
 
 #------------------------------------------------------------------------------
@@ -640,8 +479,8 @@
                 title = WINDOW_TITLE_BASE):
     """Display an error dialog box with the given message."""
-    dialog = gtk.MessageDialog(parent = parent,
-                               type = MESSAGETYPE_ERROR,
+    dialog = Gtk.MessageDialog(parent = parent,
+                               type = Gtk.MessageType.ERROR,
                                message_format = message)
-    dialog.add_button(xstr("button_ok"), RESPONSETYPE_OK)
+    dialog.add_button(xstr("button_ok"), Gtk.ResponseType.OK)
     dialog.set_title(title)
     if secondary is not None:
@@ -662,11 +501,11 @@
 
 def createFlightTypeComboBox():
-        flightTypeModel = gtk.ListStore(str, int)
+        flightTypeModel = Gtk.ListStore(str, int)
         for type in _const.flightTypes:
             name = "flighttype_" + _const.flightType2string(type)
             flightTypeModel.append([xstr(name), type])
 
-        flightType = gtk.ComboBox(model = flightTypeModel)
-        renderer = gtk.CellRendererText()
+        flightType = Gtk.ComboBox(model = flightTypeModel)
+        renderer = Gtk.CellRendererText()
         flightType.pack_start(renderer, True)
         flightType.add_attribute(renderer, "text", 0)
Index: src/mlx/gui/delaycodes.py
===================================================================
--- src/mlx/gui/delaycodes.py	(revision 840)
+++ src/mlx/gui/delaycodes.py	(revision 999)
@@ -3,5 +3,5 @@
 #------------------------------------------------------------------------------
 
-from dcdata import CAPTION, DELAYCODE, getTable
+from .dcdata import CAPTION, DELAYCODE, getTable
 
 from mlx.gui.common import *
@@ -11,181 +11,124 @@
 #------------------------------------------------------------------------------
 
-if pygobject:
-
-#------------------------------------------------------------------------------
-
-    class Viewport(gtk.Viewport):
-        """Viewport implementation that alleviates the problem with improper
-        resizing by the VBox."""
-        def __init__(self):
-            """Construct the viewport."""
-            gtk.Viewport.__init__(self)
-            self._recursive = False
+class Viewport(Gtk.Viewport):
+    """Viewport implementation that alleviates the problem with improper
+    resizing by the VBox."""
+    def __init__(self):
+        """Construct the viewport."""
+        Gtk.Viewport.__init__(self)
+        self._recursive = False
+        self._vboxHeight = None
+
+    def setVBOXHeight(self, vboxHeight):
+        """Set the height of the VBox which will be used to calculate the
+        viewport's height."""
+        self._vboxHeight = vboxHeight
+
+    def do_size_allocate(self, allocation):
+        """Called when the viewport's size is allocated.
+
+        The height in the allocation object is modified so that it is only
+        so high to fit into the VBox."""
+        if self._vboxHeight is not None:
+            allocation.y += 1
+            allocation.height = self._vboxHeight - allocation.y
             self._vboxHeight = None
-
-        def setVBOXHeight(self, vboxHeight):
-            """Set the height of the VBox which will be used to calculate the
-            viewport's height."""
-            self._vboxHeight = vboxHeight
-
-        def do_size_allocate(self, allocation):
-            """Called when the viewport's size is allocated.
-
-            The height in the allocation object is modified so that it is only
-            so high to fit into the VBox."""
-            if self._vboxHeight is not None:
-                allocation.height = self._vboxHeight - allocation.y
-                self._vboxHeight = None
-            gtk.Viewport.do_size_allocate(self, allocation)
-
-    class DelayCodeTableBase(gtk.VBox, gtk.Scrollable):
-        """PyGObject-specific base class for the delay code table."""
-        __gproperties__ = {
-            "vscroll-policy" : ( gtk.ScrollablePolicy,
-                                 "vscroll-policy",
-                                 "The vertical scrolling policy",
-                                 gtk.ScrollablePolicy.MINIMUM,
-                                 gobject.PARAM_READWRITE ),
-            "vadjustment" : ( gtk.Adjustment,
-                              "vadjustment",
-                              "The vertical adjustment",
-                              gobject.PARAM_READWRITE ),
-            "hscroll-policy" : ( gtk.ScrollablePolicy,
-                                 "hscroll-policy",
-                                 "The horizontal scrolling policy",
-                                 gtk.ScrollablePolicy.MINIMUM,
-                                 gobject.PARAM_READWRITE ),
-            "hadjustment" : ( gtk.Adjustment,
-                              "hadjustment",
-                              "The horizontal adjustment",
-                              gobject.PARAM_READWRITE )  }
-
-
-        @staticmethod
-        def _createViewport():
-            """Create an instance of the viewport class used by this base class."""
-            return Viewport()
-
-        def __init__(self):
-            """Construct the delay code table."""
-            super(DelayCodeTableBase, self).__init__()
-
-        def do_size_allocate(self, allocation):
-            """Allocate the size for the table and its children.
-
-            This sets up the VBox height in the viewport and then calls the
-            do_size_allocate() function of VBox()."""
-            self._viewport.setVBOXHeight(allocation.height)
-            gtk.VBox.do_size_allocate(self, allocation)
-            self.allocate_column_sizes(allocation)
-
-        def do_get_property(self, prop):
-            """Get the value of one of the properties defined above.
-
-            The request is forwarded to the viewport."""
-            if prop.name=="vscroll-policy":
-                return self._viewport.get_vscroll_policy()
-            elif prop.name=="hscroll-policy":
-                return self._viewport.get_hscroll_policy()
-            elif prop.name=="vadjustment":
-                return self._viewport.get_vadjustment()
-            elif prop.name=="hadjustment":
-                return self._viewport.get_hadjustment()
-            else:
-                raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_get_property" %
-                                     (prop.name,))
-
-        def do_set_property(self, prop, value):
-            """Set the value of the adjustment properties defined above.
-
-            The adjustments are forwarded to the viewport."""
-            if prop.name=="vadjustment":
-                self._viewport.set_vadjustment(value)
-            elif prop.name=="hadjustment":
-                self._viewport.set_hadjustment(value)
-                self._treeView.set_hadjustment(value)
-            else:
-                raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_set_property" %
-                                     (prop.name,))
-
-        def setStyle(self):
-            """Set the style of the event box from the treeview."""
-
-    class Alignment(gtk.Alignment):
-        """An alignment that remembers the width it was given."""
-        def __init__(self, xalign = 0.0, yalign=0.0,
-                     xscale = 0.0, yscale = 0.0 ):
-            """Construct the alignment."""
-            super(Alignment, self).__init__(xalign = xalign, yalign = yalign,
-                                            xscale = xscale, yscale = yscale)
-            self.allocatedWidth = 0
-
-        def do_size_allocate(self, allocation):
-            """Called with the new size allocation."""
-            self.allocatedWidth = allocation.width
-            gtk.Alignment.do_size_allocate(self, allocation)
-
-#------------------------------------------------------------------------------
-
-else: # pygobject
-
-#------------------------------------------------------------------------------
-
-    class DelayCodeTableBase (gtk.VBox):
-        """Base class of the delay code table for PyGtk."""
-
-        __gsignals__ = {
-            "set-scroll-adjustments": (
-                gobject.SIGNAL_RUN_LAST,
-                gobject.TYPE_NONE, (gtk.Adjustment, gtk.Adjustment))
-                }
-
-        @staticmethod
-        def _createViewport():
-            """Create an instance of the viewport class used by this base class."""
-            return gtk.Viewport()
-
-        def __init__(self):
-            """Construct the base class."""
-            super(DelayCodeTableBase, self).__init__()
-            self.set_set_scroll_adjustments_signal("set-scroll-adjustments")
-            self.connect("size-allocate", self._do_size_allocate)
-
-        def do_set_scroll_adjustments(self, hAdjustment, vAdjustment):
-            """Set the adjustments on the viewport."""
-            self._viewport.set_hadjustment(hAdjustment)
-            self._viewport.set_vadjustment(vAdjustment)
-            self._treeView.set_hadjustment(hAdjustment)
-
-        def _do_size_allocate(self, widget, allocation):
-            """Handler of the size-allocate signal.
-
-            Calls allocate_column_sizes()."""
-            self.allocate_column_sizes(allocation)
-
-        def setStyle(self):
-            """Set the style of the event box from the treeview."""
-            if self._treeView is not None:
-                style = self._treeView.rc_get_style()
-                self._eventBox.modify_bg(0, style.bg[2])
-                self._eventBox.modify_fg(0, style.fg[2])
-
-    class Alignment(gtk.Alignment):
-        """An alignment that remembers the width it was given."""
-        def __init__(self, xalign = 0.0, yalign=0.0,
-                     xscale = 0.0, yscale = 0.0 ):
-            """Construct the alignment."""
-            super(Alignment, self).__init__(xalign = xalign, yalign = yalign,
-                                            xscale = xscale, yscale = yscale)
-            self.allocatedWidth = 0
-            self.connect("size-allocate", self._do_size_allocate)
-
-        def _do_size_allocate(self, widget, allocation):
-            """Called with the new size allocation."""
-            self.allocatedWidth = allocation.width
-
-#------------------------------------------------------------------------------
-
-class CheckButton(gtk.CheckButton):
+        Gtk.Viewport.do_size_allocate(self, allocation)
+
+class DelayCodeTableBase(Gtk.VBox, Gtk.Scrollable):
+    """PyGObject-specific base class for the delay code table."""
+    __gproperties__ = {
+        "vscroll-policy" : ( Gtk.ScrollablePolicy,
+                             "vscroll-policy",
+                             "The vertical scrolling policy",
+                             Gtk.ScrollablePolicy.MINIMUM,
+                             GObject.PARAM_READWRITE ),
+        "vadjustment" : ( Gtk.Adjustment,
+                          "vadjustment",
+                          "The vertical adjustment",
+                          GObject.PARAM_READWRITE ),
+        "hscroll-policy" : ( Gtk.ScrollablePolicy,
+                             "hscroll-policy",
+                             "The horizontal scrolling policy",
+                             Gtk.ScrollablePolicy.MINIMUM,
+                             GObject.PARAM_READWRITE ),
+        "hadjustment" : ( Gtk.Adjustment,
+                          "hadjustment",
+                          "The horizontal adjustment",
+                          GObject.PARAM_READWRITE )  }
+
+
+    @staticmethod
+    def _createViewport():
+        """Create an instance of the viewport class used by this base class."""
+        return Viewport()
+
+    def __init__(self):
+        """Construct the delay code table."""
+        super(DelayCodeTableBase, self).__init__()
+
+    def do_size_allocate(self, allocation):
+        """Allocate the size for the table and its children.
+
+        This sets up the VBox height in the viewport and then calls the
+        do_size_allocate() function of VBox()."""
+        self._viewport.setVBOXHeight(allocation.height)
+        Gtk.VBox.do_size_allocate(self, allocation)
+        self.allocate_column_sizes(allocation)
+
+    def do_get_property(self, prop):
+        """Get the value of one of the properties defined above.
+
+        The request is forwarded to the viewport."""
+        if prop.name=="vscroll-policy":
+            return self._viewport.get_vscroll_policy()
+        elif prop.name=="hscroll-policy":
+            return self._viewport.get_hscroll_policy()
+        elif prop.name=="vadjustment":
+            return self._viewport.get_vadjustment()
+        elif prop.name=="hadjustment":
+            return self._viewport.get_hadjustment()
+        else:
+            raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_get_property" %
+                                 (prop.name,))
+
+    def do_set_property(self, prop, value):
+        """Set the value of the adjustment properties defined above.
+
+        The adjustments are forwarded to the viewport."""
+        if prop.name=="vadjustment":
+            self._viewport.set_vadjustment(value)
+        elif prop.name=="hadjustment":
+            self._viewport.set_hadjustment(value)
+            self._treeView.set_hadjustment(value)
+        else:
+            raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_set_property" %
+                                 (prop.name,))
+
+    def setStyle(self):
+        """Set the style of the event box from the treeview."""
+
+class Alignment(Gtk.Alignment):
+    """An alignment that remembers the width it was given."""
+    def __init__(self, xalign = 0.0, yalign=0.0,
+                 xscale = 0.0, yscale = 0.0 ):
+        """Construct the alignment."""
+        super(Alignment, self).__init__(xalign = xalign, yalign = yalign,
+                                        xscale = xscale, yscale = yscale)
+        self.allocatedWidth = 0
+
+    def do_size_allocate(self, allocation):
+        """Called with the new size allocation."""
+        self.allocatedWidth = allocation.width
+        Gtk.Alignment.do_size_allocate(self, allocation)
+
+class TreeView(Gtk.TreeView):
+    def do_size_allocate(self, allocation):
+        allocation.height += 1
+        Gtk.TreeView.do_size_allocate(self, allocation)
+
+#------------------------------------------------------------------------------
+
+class CheckButton(Gtk.CheckButton):
     """A check button that contains a reference to a row in the delay code
     data table."""
@@ -241,5 +184,5 @@
         self._delayCodeData = None
 
-        self._treeView = gtk.TreeView(gtk.ListStore(str, str))
+        self._treeView = TreeView(Gtk.ListStore(str, str))
         self._treeView.set_rules_hint(True)
 
@@ -249,5 +192,5 @@
         self._checkButtons = []
 
-        self._eventBox = gtk.EventBox()
+        self._eventBox = Gtk.EventBox()
 
         self._table = None
@@ -255,5 +198,5 @@
         self._viewport = self._createViewport()
         self._viewport.add(self._eventBox)
-        self._viewport.set_shadow_type(SHADOW_NONE)
+        self._viewport.set_shadow_type(Gtk.ShadowType.NONE)
 
         self.pack_start(self._viewport, True, True, 0)
@@ -311,14 +254,14 @@
         numRows = len(rows)
 
-        column = gtk.TreeViewColumn("", gtk.CellRendererText())
-        column.set_sizing(TREE_VIEW_COLUMN_FIXED)
+        column = Gtk.TreeViewColumn("", Gtk.CellRendererText())
+        column.set_sizing(Gtk.TreeViewColumnSizing.FIXED)
         self._treeView.append_column(column)
 
         for header in headers:
-            column = gtk.TreeViewColumn(header, gtk.CellRendererText())
-            column.set_sizing(TREE_VIEW_COLUMN_FIXED)
+            column = Gtk.TreeViewColumn(header, Gtk.CellRendererText())
+            column.set_sizing(Gtk.TreeViewColumnSizing.FIXED)
             self._treeView.append_column(column)
 
-        self._table = gtk.Table(numRows, numColumns)
+        self._table = Gtk.Table(numRows, numColumns)
         self._table.set_homogeneous(False)
         self._table.set_col_spacings(16)
@@ -333,12 +276,12 @@
             (type, elements) = rows[i]
             if type==CAPTION:
-                alignment = gtk.Alignment(xalign = 0.0, yalign = 0.5,
+                alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.5,
                                           xscale = 1.0)
-                label = gtk.Label("<b>" + elements + "</b>")
+                label = Gtk.Label("<b>" + elements + "</b>")
                 label.set_use_markup(True)
                 label.set_alignment(0.0, 0.5)
                 alignment.add(label)
                 self._table.attach(alignment, 1, numColumns, i, i+1,
-                                   yoptions = FILL)
+                                   yoptions = Gtk.AttachOptions.FILL)
                 self._table.set_row_spacing(i, 8)
             elif type==DELAYCODE:
@@ -349,18 +292,20 @@
                 alignment.add(checkButton)
                 self._table.attach(alignment, 0, 1, i, i+1,
-                                   xoptions = FILL, yoptions = FILL)
+                                   xoptions = Gtk.AttachOptions.FILL,
+                                   yoptions = Gtk.AttachOptions.FILL)
                 if firstDelayCodeRow:
                     self._alignments.append(alignment)
 
                 for j in range(0, numColumns-1):
-                    label = gtk.Label(elements[j])
+                    label = Gtk.Label(elements[j])
                     label.set_alignment(0.0, 0.5)
                     alignment = Alignment(xalign = 0.5, yalign = 0.5,
                                           xscale = 1.0)
                     alignment.add(label)
-                    xoptions = FILL
-                    if j==(numColumns-2): xoptions |= EXPAND
+                    xoptions = Gtk.AttachOptions.FILL
+                    if j==(numColumns-2): xoptions |= Gtk.AttachOptions.EXPAND
                     self._table.attach(alignment, j+1, j+2, i, i+1,
-                                       xoptions = xoptions, yoptions = FILL)
+                                       xoptions = xoptions,
+                                       yoptions = Gtk.AttachOptions.FILL)
                     if firstDelayCodeRow:
                         self._alignments.append(alignment)
